/**
 * Created by yeanzhi on 17/6/7.
 */
'use strict';

exports.filterFileName = function (filename) {
    if (/^\s+$/gi.test(filename)) {
        return {
            error: {
                msg: '文件名不能为纯空格'
            }
        };
    }
    if (/^\.{1,2}$/.test(filename)) {
        return {
            error: {
                msg: "文件名不能为.或者.."
            }
        };
    }

    if (/^[^<>\|\*\?\/]*$/.test(filename)) {
        var b1 = new Buffer(filename);
        var bytes = Array.prototype.slice.call(b1, 0);
        if (bytes.length > 128) {
            return {
                error: {
                    msg: '文件名不能超过128字节'
                }
            };
        }
    } else {
        return {
            error: {
                msg: '文件名不能出现<>|*?/字符'
            }
        };
        return false;
    }
    return true;
};