/**
 * Created by yeanzhi on 17/6/1.
 */
'use strict';

var isPS = exports.isPs = function (name) {
    return (/^.*\.(psd)$/gi.test(name)
    );
};
var isAI = exports.isAI = function (name) {
    return (/^.*\.(ai|eps)$/gi.test(name)
    );
};

var isGif = exports.isGif = function (name) {
    return (/^.*\.(gif)$/gi.test(name)
    );
};

var isMSDoc = exports.isMSDoc = function (name) {
    return (/^.*\.(doc|docx|dotx|dot|dotm)$/gi.test(name)
    );
};

var isMSExcel = exports.isMSExcel = function (name) {
    return (/^.*\.(xls|xlsx|xlsm|xlm|xlsb)$/gi.test(name)
    );
};
var isMSPPT = exports.isMSPPT = function (name) {
    return (/^.*\.(ppt|pptx|pps|ppsx|potx|pot|pptm|potm|ppsm)$/gi.test(name)
    );
};
var isPDF = exports.isPDF = function (name) {
    return (/^.*\.(pdf)$/gi.test(name)
    );
};

var isAudio = exports.isAudio = function (name) {
    return (/^.*\.(mp2|wav|mp3|au|wma|aif)$/gi.test(name)
    );
};
var isVideo = exports.isVideo = function (name) {
    return (/^.*\.(3gpp|asf|wmv|avi|flv|f4v|mkv|mov|mp4|m4a|mpeg|mpg|ts|ogg|mts|wma|rm|rmvb|webm)$/gi.test(name)
    );
};

var isText = exports.isText = function (name) {
    return (/^.*\.(text|txt|html|htm|htmlx|js|java|c|cpp|go|py|ry|swift|ruby|oc|m|h|css|cs|jsp|asp|php|md|markdown|sass|scss|less|lisp|sql|sh|bash|json|log)$/gi.test(name)
    );
};

var isZip = exports.isZip = function (name) {
    return (/^.*\.(zip|rar)$/gi.test(name)
    );
};

var isPicture = exports.isPicture = function (name) {
    return (/^.*\.(bmp|gif|jpg|png|tiff|jpeg)$/gi.test(name)
    );
};

var isKey = exports.isKey = function (name) {
    return (/^.*\.(key)$/gi.test(name)
    );
};

var isNumbers = exports.isNumbers = function (name) {
    return (/^.*\.(numbers)$/gi.test(name)
    );
};

var isPages = exports.isPages = function (name) {
    return (/^.*\.(pages)$/gi.test(name)
    );
};

var isSvg = exports.isSvg = function (name) {
    return (/^.*\.(svg)$/gi.test(name)
    );
};

var isSketch = exports.isSketch = function (name) {
    return (/^.*\.(sketch)$/gi.test(name)
    );
};

var isIWork = exports.isIWork = function (name) {
    return isKey(name) || isPages(name) || isNumbers(name);
};

var isDoc = exports.isDoc = function (name) {
    return isMSDoc(name) || isMSExcel(name) || isMSPPT(name) || isPDF(name);
};

var isMedia = exports.isMedia = function (name) {
    return isAudio(name) || isVideo(name);
};

var isImg = exports.isImg = function (name) {
    return isPicture(name) || isPS(name) || isAI(name);
};

var isPreview = function isPreview(name) {
    return isImg(name) || isDoc(name) || isText(name) || isZip(name) || isMedia(name) || isIWork(name);
};