/**
 * Created by yeanzhi on 17/6/1.
 */
'use strict';

exports.replaceInternalUrl = function (url) {
    var newUrl = url.replace(/mss\.sankuai\.com/i, 'mss.vip.sankuai.com').replace(/dxw\.sankuai\.com/i, 'dxw-in.sankuai.com').replace(/daxiang\.sankuai\.com/i, 'dxw-in.sankuai.com').replace(/xs\.xm\.sankuai\.com/i, 'xs-in.xm.sankuai.com').replace(/file\.neixin\.cn/i, 'file.vip.neixin.cn').replace(/file\.sankuai\.com/i, 'file.vip.neixin.cn').replace(/file-st\.neixin\.cn/i, 'file-st.vip.neixin.cn').replace(/file2\.sankuai\.com/i, 'file-st.vip.neixin.cn');
    return newUrl !== url ? newUrl.replace('https://', 'http://') : newUrl;
};
var TOP_LEVEL_DOMAIN = 'museum|travel|aero|arpa|asia|coop|info|jobs|mobi|name|biz|cat|com|edu|gov|int|mil|net|org|pro|tel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sk|sl|sm|sn|so|sr|ss|st|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|za|zm|zw|dp';

var REG_URL_STR = '(?:(https?|ftp|mtdaxiang):\\/\\/)?' + //匹配协议， $1
'(?:(@)?' + //作为向前查找的hack， $2
'(\\d{1,3}(?:\\.\\d{1,3}){3})|' + //匹配ip， $3
'([-a-z_0-9.]{2,256}\\.(?:' + TOP_LEVEL_DOMAIN + ')\\b)' + //匹配域， $4
')' + '(:\\d{1,5})?' + //匹配端口, $5
'(\\/[-a-z_0-9@:%+.~&/=()!\'*$]*)?' + //匹配路径 $6
'(\\?[-a-z_0-9@:%+.~&/=()!\';{}*?$]*)?' + //匹配查询参数 $7
'(\\#[-a-z_0-9@:%+.~&/=()!\';{}*?#^$]*)?'; //匹配锚点， $8
exports.isUrl = function (url) {
    var REG_URL = new RegExp(REG_URL_STR, 'gi');
    return REG_URL.test(url);
};
var parseUrl = exports.parseUrl = function (url, _ref) {
    var _ref$pathFlag = _ref.pathFlag,
        pathFlag = _ref$pathFlag === undefined ? false : _ref$pathFlag,
        _ref$paramFlag = _ref.paramFlag,
        paramFlag = _ref$paramFlag === undefined ? true : _ref$paramFlag;

    var REG_URL = new RegExp(REG_URL_STR, 'gi');
    REG_URL.lastIndex = 0;
    var result = REG_URL.exec(url) || [];
    if (result[0] !== result['input']) {
        //未命中全部
    }

    var protocol = result[1];
    var IP = result[3];
    var domain = result[4];
    var port = result[5];
    var path = result[6];
    var param = result[7] ? decodeURIComponent(result[7].slice(1)) : '';
    var anchor = result[8];

    return {
        protocol: protocol || 'http',
        IP: IP || '',
        domain: domain || '',
        port: port || '80',
        path: (pathFlag ? parsePath(path) : path) || '',
        param: (paramFlag ? parseParam(param) : param) || '',
        anchor: anchor || ''
    };
};

var parsePath = exports.parsePath = function (path) {
    if (path) {
        var result = path.split('/');
        result.shift();

        return result;
    } else {
        return [];
    }
};

var parseParam = exports.parseParam = function (param) {
    var result = {},
        kv = param ? param.split('&') : [],
        tmp = void 0;
    for (var i in kv) {
        tmp = kv[i].split('=');
        result[tmp[0]] = tmp[1];
    }

    return result;
};