/**
 * Created by yeanzhi on 17/6/1.
 */
'use strict';
var HTML_CHARS = {
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&apos;',
    '&': '&amp;'
};
/**
 * HTML标签内容过滤
 * @param {String} html
 * @param {Boolean} isAll
 * @return {String}
 */
exports.escapeHtml = function(html, isAll) {
    return ('' + html).replace(new RegExp('[<>"\'' + (isAll ? '&]' : ']'), 'g'), function($0) {
        return HTML_CHARS[$0];
    });
}
/**
 * 把空格和换行转成html encode的形式
 * @param {string} text
 * @returns {string}
 */
exports.spaceToHtml = function(text) {
    text = ('' + text).replace(/[ ]+/g, function($0) {
        return ' ' + ($0.length > 1 ? $0.substr(1).replace(/ /g, '&nbsp;') : '');
    });

    return text.replace(/(\u000a|\u000D)/g, '<br/>');
}

